Index: trunk/external-alma/oldasdm2ASAP/OldASDMFiller.cc
===================================================================
--- trunk/external-alma/oldasdm2ASAP/OldASDMFiller.cc	(revision 2301)
+++ trunk/external-alma/oldasdm2ASAP/OldASDMFiller.cc	(revision 2407)
@@ -76,6 +76,4 @@
   Vector<casa::Double> antpos = table_->getHeader().antennaposition ;
 
-  //STHeader hdr = table_->getHeader() ;
-  
   // data selection
   reader_->select() ;
@@ -103,5 +101,4 @@
 
   // CYCLENO
-  //unsigned int cycleno = 0 ;
   map< unsigned int, unsigned int > cycleno ;
   map< unsigned int, unsigned int >::iterator citer ;
@@ -111,5 +108,4 @@
       //logsink_->postLocally( LogMessage("start configDescId "+String::toString(configDescIdList[icon])+" fieldId "+String::toString(fieldIdList[ifield]),LogOrigin(className_,funcName,WHERE)) ) ;
 
-      //Bool status = reader_->setMainRow( configDescIdList[icon], fieldIdList[ifield] ) ;
       if ( !(reader_->setMainRow( configDescIdList[icon], fieldIdList[ifield] )) ) {
         //logsink_->postLocally( LogMessage("skip configDescId "+String::toString(configDescIdList[icon])+" fieldId "+String::toString(fieldIdList[ifield]),LogOrigin(className_,funcName,WHERE)) ) ;
@@ -132,7 +128,5 @@
 
         // scan and subscan
-        //unsigned int scanno = reader_->getScanNo() ;
         unsigned int scanno = reader_->getScanNoOfCurrentRow() ;
-        //uInt subscanno = reader_->getSubscanNo() ;
         citer = cycleno.find( scanno ) ;
         if ( citer == cycleno.end() )
@@ -157,9 +151,7 @@
 
           // subscan number
-          //unsigned int subscanno = reader_->getSubscanNo( idata ) ;
           unsigned int subscanno = reader_->getSubscanNo() ;
 
           // IFNO
-          //uInt ifno = reader_->getIFNo( idata ) ;
           uInt ifno = reader_->getIFNo() ;
 
@@ -172,11 +164,4 @@
           double sysVel ;
           vector<double> rf ;
-          //reader_->getSourceProperty( idata, 
-          //                            srcname, 
-          //                            fieldname,
-          //                            srcDirection,
-          //                            srcProperMotion,
-          //                            sysVel,
-          //                            rf ) ;
           reader_->getSourceProperty( srcname, 
                                       fieldname,
@@ -193,6 +178,4 @@
           
           // time and interval
-          //casa::Double mjd = (casa::Double)(reader_->getTime( idata )) ;
-          //casa::Double interval = (casa::Double)(reader_->getInterval( idata )) ;
           casa::Double mjd = (casa::Double)(reader_->getTime()) ;
           casa::Double interval = (casa::Double)(reader_->getInterval()) ;
@@ -211,5 +194,4 @@
 
           // fill FLAGROW
-          //unsigned int flagrow = reader_->getFlagRow( idata ) ;
           unsigned int flagrow = reader_->getFlagRow() ;
           setFlagrow( (uInt)flagrow ) ;
@@ -221,10 +203,4 @@
           float windspeed ;
           float windaz ;
-          //reader_->getWeatherInfo( idata,
-          //                         temperature, 
-          //                         pressure,
-          //                         humidity,
-          //                         windspeed,
-          //                         windaz ) ;
           reader_->getWeatherInfo( temperature, 
                                    pressure,
@@ -243,9 +219,4 @@
           double el ;
           vector<double> srate ;
-          //reader_->getPointingInfo( idata,
-          //                          dir,
-          //                          az,
-          //                          el,
-          //                          srate ) ;
           reader_->getPointingInfo( dir,
                                     az,
@@ -275,5 +246,4 @@
           }
           else {
-            //reader_->getFrequency( idata, refpix, refval, incr, freqref ) ;
             reader_->getFrequency( refpix, refval, incr, freqref ) ;
             refval = (double)toLSRK( casa::Double(refval), 
@@ -291,5 +261,4 @@
 
           // loop on polarization
-          //vector<unsigned int> dataShape = reader_->getDataShape( idata ) ;
           vector<unsigned int> dataShape = reader_->getDataShape() ;
 //           ostringstream oss ;
@@ -304,5 +273,4 @@
           //logsink_->postLocally( LogMessage(oss.str(),LogOrigin(className_,funcName,WHERE)) ) ;
                                      
-          //int numPol = reader_->getNumPol( idata ) ;
           unsigned int numPol = dataShape[0] ;
           unsigned int numChan = dataShape[1] ;
@@ -311,14 +279,11 @@
 
           // OPACITY
-          //vector<float> tau = reader_->getOpacity( idata ) ;
           vector<float> tau = reader_->getOpacity() ;
           Vector<casa::Float> opacity = toVector( tau, numPol ) ;
 
           // SPECTRA, FLAGTRA, TSYS, TCAL
-          //float *sp = reader_->getSpectrum( idata ) ;
           float *sp = reader_->getSpectrum() ;
           vector< vector<float> > ts ;
           vector< vector<float> > tc ;
-          //reader_->getTcalAndTsys( idata, tc, ts ) ;
           reader_->getTcalAndTsys( tc, ts ) ;
           Matrix<casa::Float> spectra = toMatrix( sp, numPol, numChan ) ;